#!/bin/bash

############
# This file starts a SkinnyDebbie session under IceWM. It should be called from
# ~/.icewm/startup. You should probably not edit this file.
############

skinnyRscRoot=~/.config/skinny

#sudo -k
skinny-screenres
update-menus --menumethod /etc/menu-methods/icewm-common
xscreensaver-command -exit
xscreensaver -no-splash &
killall icewmbg

# temporarily disable media insertion announcements
echo "false" > ${skinnyRscRoot}/exc/enable-media-annc

# start different daemons, etc. depending on the default file manager
fm=${skinnyRscRoot}/my-file-manager
if [ -s "$fm" ] ; then
	fmCmd=`cat $fm`
else
	fmCmd=rox-filer
fi

case $fmCmd in
	rox-filer)
		skinny-start-ivman &
		# TODO: start libtrash
		(nitrogen --restore; ${skinnyRscRoot}/conky/start-conky.sh)&
		;;
	rox)
		skinny-start-ivman &
		# TODO: start libtrash
		rox --pinboard=myDesktop
		;;
	# the following are not yet supported
	#~ xfe)
		#~ skinny-start-ivman &
		#~ (nitrogen --restore; ${skinnyRscRoot}/conky/start-conky.sh)&
		#~ ;;
	#~ pcmanfm)
		#~ pcmanfm -d
		#~ # consider using ivman if you are using the no-hal version of pcmanfm
		#~ #skinny-start-ivman &
		#~ ;;
	#~ thunar)
		#~ (nitrogen --restore; ${skinnyRscRoot}/conky/start-conky.sh)&
		#~ thunar --daemon
		#~ ;;
	*)
		echo "Unknown or unsupported file manager."
		;;
esac

# (re)enable media insertion announcements
(sleep 2; echo "true" > ${skinnyRscRoot}/exc/enable-media-annc)&

# launch check-updates utility
#TODO: move checkupdates someplace more appropriate, e.g. /usr/local/bin or /opt/<whatever>
(sleep 30; ~/.Apps/checkupdates/check-updates.sh&)&

#
# Execute commands listed in ~/.config/skinny/startup-items
bash ${skinnyRscRoot}/my-startup-items

# TODO: try to make this work instead:
# Execute commands listed in ~/.config/skinny/startup-items
# by stripping out comments and blank lines and then eval-ing
# what's left.
#
#~ while read line ; do
	#~ # sed cmd from http://www.imped.net/2007/11/22/remove-comments-and-empty-lines-sed-one-liner/
	#~ line=`echo $line | sed -e 's/#.*//' -e 's/[ ^I]*$//' -e '/^$/ d'`
	#~ if [ -n "$line" ] ; then
		#~ eval "($line ;)&"
	#~ fi
#~ done < ${skinnyRscRoot}/my-startup-items
